package xyz.veronie.bgg.ui.filters;

import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.Creatable;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import xyz.veronie.bgg.result.ResultConfigManager;
import xyz.veronie.bgg.types.EventConstants;

/// These are the controls to retrieve thing IDs for a given family ID
@Creatable
public class FamilySourceFilter {

	@Inject private IEventBroker eventBroker;
	@Inject private ResultConfigManager configManager;
	
	public void create(Composite parent, int style) {
        GridLayout filterLayout = new GridLayout(2, false);
        parent.setLayout(filterLayout);
        
        Label lblFamily = new Label(parent, SWT.LEFT);
        lblFamily.setText("Family ID: ");
        lblFamily.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		        
        Combo cbFamilyId = new Combo(parent, SWT.DROP_DOWN);
        cbFamilyId.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
        cbFamilyId.addSelectionListener(new SelectionAdapter() {
            public void widgetDefaultSelected(SelectionEvent e) {
            	try {
	            	setFamilyId(Integer.parseInt(cbFamilyId.getText()));
	            	System.out.println("set family id to '" + configManager.getResultConfig().geeklistId + "'");					
				} 
				catch (NumberFormatException ex) {
					MessageDialog.openError(parent.getShell(), "Input error", "FamilyId must be a whole number.");
				}
            	System.out.println("set family id to '" + configManager.getResultConfig().familyId + "'");
            }
        });
        cbFamilyId.addFocusListener(new FocusListener() {
			
			@Override
			public void focusLost(FocusEvent e) {
				try {
	            	setFamilyId(Integer.parseInt(cbFamilyId.getText()));
	            	System.out.println("set family id to '" + configManager.getResultConfig().geeklistId + "'");					
				} 
				catch (NumberFormatException ex) {
					MessageDialog.openError(parent.getShell(), "Input error", "FamilyId must be a whole number.");
				}
            	System.out.println("set family id to '" + configManager.getResultConfig().familyId + "'");
			}
			
			@Override
			public void focusGained(FocusEvent e) {
				// nothing
			}
		});
        parent.layout();
	}


	public void setFamilyId(int familyId) {
		if(eventBroker != null) {
			eventBroker.post(EventConstants.TOPIC_FAMILY_CHANGED, familyId);
		} else {
		   	System.out.println("setFamilyId: eventBroker is null.");
		}
	}
}
